//
//   Registers of the CPU
//

#import "DataTypes.h"

typedef struct CPURegisters {
    Digits_14 A;
    Digits_14 B;
    Digits_14 C;
    Digits_14 M;
    Digits_14 N;
    Digit PQ[2];
    Bits_16 PC;
    Bits_8 G;
    Bits_8 ST;
    Bits_8 T;
    Bits_14 FI;
    Bits_8 KY;
    Bits_6 XST;
    Bits_16 stack[4];
    Bit r;              // Selected pointer
    Bit carry;
    Bit mode;           // DEC_MODE or HEX_MODE
    Bits_6 ramchip;     // Selected ram chip
    Bits_4 ramreg;      // Selected register of selected ram chip
    Bits_8 peripheral;  // Selected peripheral
    Bit keyDown;        // Set if a key is being held down
} CPURegisters;
