//
//  DebugController.h
//  HP41
//
//  Created by greg on Wed Aug 13 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@class CPU;
@class Bus;
@class Display;
@class RegisterDisplay;
@class DigitsDisplay;
@class BitsDisplay;
@class ModeDisplay;
@class RamDisplay;
@class RomDisplay;

@interface DebugController : NSObject {
    IBOutlet CPU *cpu;
    IBOutlet Bus *bus;
    IBOutlet Display *display;
    IBOutlet NSWindow *registerWindow;
    IBOutlet DigitsDisplay *displayA;
    IBOutlet DigitsDisplay *displayB;
    IBOutlet DigitsDisplay *displayC;
    IBOutlet DigitsDisplay *displayM;
    IBOutlet DigitsDisplay *displayN;
    IBOutlet DigitsDisplay *displayP;
    IBOutlet DigitsDisplay *displayQ;
    IBOutlet BitsDisplay *displayPC;
    IBOutlet BitsDisplay *displayG;
    IBOutlet BitsDisplay *displayST;
    IBOutlet BitsDisplay *displayT;
    IBOutlet BitsDisplay *displayFI;
    IBOutlet BitsDisplay *displayKY;
    IBOutlet BitsDisplay *displayXST;
    IBOutlet BitsDisplay *displayStack0;
    IBOutlet BitsDisplay *displayStack1;
    IBOutlet BitsDisplay *displayStack2;
    IBOutlet BitsDisplay *displayStack3;
    IBOutlet ModeDisplay *displayRselect;
    IBOutlet BitsDisplay *displayCarry;
    IBOutlet ModeDisplay *displayMode;
    IBOutlet BitsDisplay *displayRamChipSelect;
    IBOutlet BitsDisplay *displayRamRegSelect;
    IBOutlet BitsDisplay *displayPeriphSelect;
    IBOutlet BitsDisplay *displayKeyDown;
    IBOutlet ModeDisplay *displayPowerMode;
    IBOutlet DigitsDisplay *displayDispA;
    IBOutlet DigitsDisplay *displayDispB;
    IBOutlet DigitsDisplay *displayDispC;
    IBOutlet BitsDisplay *displayDispE;
    IBOutlet RamDisplay *displayCurrentRam;
    IBOutlet RomDisplay *displayRom;
    IBOutlet NSTextView *epromField;
    IBOutlet NSButton *breakpointSwitch;
    IBOutlet NSMatrix *numberBaseSelector;
    IBOutlet NSTextField *breakpointField;
    IBOutlet NSTextField *gotoField;
    IBOutlet NSButton *haltButton;
    IBOutlet NSButton *stepButton;
    IBOutlet NSButton *runButton;
    IBOutlet NSButton *incPcButton;
    IBOutlet NSButton *decPcButton;
    IBOutlet NSButton *programEpromButton;
}

- (void) show: (BOOL) shown;
- (BOOL) running;
- (int) pc;
//- (int) breakpoint;
- (BOOL) getBreakpoint: (int *) addr;
- (BOOL) readRomLocation: (int) addr into: (int *) data;
- (IBAction) halt: (id) sender;
- (IBAction) step: (id) sender;
- (IBAction) run: (id) sender;
- (IBAction) incPc: (id) sender;
- (IBAction) decPc: (id) sender;
- (IBAction) reset: (id) sender;
- (IBAction) resetToEprom: (id) sender;
- (IBAction) programEprom: (id) sender;
- (IBAction) updateBreakpoint: (id) sender;
- (IBAction) numberModeControlChanged: (id) sender;
- (IBAction) gotoAddress: (id) sender;
- (void) updateButtons;
- (void) updateDisplays;
- (void) registerChanged: (RegisterDisplay *) display;
//- (void) reportUnimplementedInstruction;
- (void) alert: (NSString *) message;

@end
