//
//  Display.h
//  HP41
//
//  Created by greg on Sun Aug 10 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "HP41Font.h"
#import "DataTypes.h"
#import "Peripheral.h"

@class Bus;
@class DebugController;

enum {
    numDisplayCells = 12,
    numAnnunciators = 12,
};

typedef Digit Digits_12[12];

typedef struct DisplayRegisters {
    Digits_12 A;
    Digits_12 B;
    Digits_12 C;
    Bits_12   E;
} DisplayRegisters;

@interface Display : NSView <Peripheral> {
    IBOutlet DebugController *debugController;
    Bus *bus; // borrowed
    DisplaySegmentPaths segmentPaths;
    DisplayFont displayFont;
    NSColor *foregroundColor;
    NSFont *annunciatorFont;
    NSPoint annunciatorPositions[numAnnunciators];
    //DisplaySegmentMap cells[numDisplayCells];
    //BOOL annunciators[numAnnunciators];
    BOOL on;
    int updateCountdown;
    @public
    DisplayRegisters registers;
}

- (float) cellWidth;
- (void) timeSlice: (NSTimer *) timer;

@end
