//
//  DocViewerController.h
//  HP41
//
//  Created by greg on Sun Aug 24 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@class PDFView;
@class PageTabView;
struct DocumentDesc;

enum DocViewerMode {
    onePageMode = 1,
    twoPageMode = 2
};

@interface DocViewerController : NSObject {
    IBOutlet NSWindow *window;
    IBOutlet PDFView *leftPageView;
    IBOutlet PDFView *rightPageView;
    IBOutlet PageTabView *leftTabView;
    IBOutlet PageTabView *rightTabView;
    IBOutlet NSView *extraControls;
    IBOutlet NSTextField *physicalPageField;
    NSPDFImageRep *pdf;
    NSArray *tabs;
    enum DocViewerMode mode;
    BOOL extraControlsVisible;
    int currentPage;
}

- (id) initWithDesc: (struct DocumentDesc *) desc;
- (NSWindow *) window;
- (NSPDFImageRep *) pdf;
- (int) numPages;
- (int) currentPage;
- (NSArray *) tabs;
- (BOOL) isShown;
- (void) show: (BOOL) shown;
- (void) installPdfFile: (NSString *) filename;
- (BOOL) installPdfResource: (NSString *) rsrcName;
- (NSSize) adjustWindowSize: (NSSize) proposedSize;
- (int) currentPageForSide: (enum LeftOrRight) side;
- (int) pageNumberForPageView: (PDFView *) view;
- (BOOL) tabViewIsEnabled: (PageTabView *) view;
- (BOOL) allTabsAreTogether;
- (void) goToPage: (int) newPage;
- (void) pageViewClicked: (PDFView *) view atPoint: (NSPoint) p;
- (IBAction) physicalPageNoChanged: (id) sender;
- (IBAction) goToFrontPage: (id) sender;
- (IBAction) goToBackPage: (id) sender;
- (IBAction) goToPreviousPage: (id) sender;
- (IBAction) goToNextPage: (id) sender;
- (int) imageInterpolationPreference;

@end
