//
//  RamChip.m
//  HP41
//
//  Created by greg on Thu Aug 14 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import "RamChip.h"
#import "DataOperations.h"

@implementation RamChip

- (id) init {
    [self initWithMask: 0xffff];
    return self;
}

- (id) initWithMask: (int) mask {
    self->registerMask = mask;
    return self;
}

- (BOOL) readLocation: (int) reg into: (Digits_14) data {
    if (self->registerMask & (1 << reg)) {
        CopyDigits(self->registers[reg], data, 14);
        return YES;
    }
    else {
        FillDigits(data, 0, 14);
        return NO;
    }
}

- (BOOL) writeLocation: (int) reg from: (const Digits_14) data {
    if (self->registerMask & (1 << reg)) {
        CopyDigits(data, self->registers[reg], 14);
        return YES;
    }
    else
        return NO;
}

@end
