//
//  RamDisplay.m
//  HP41
//
//  Created by greg on Thu Aug 14 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import "RamDisplay.h"
#import "Bus.h"

@implementation RamDisplay

- (void) attachTo: (int *) chipSelector {
    self->chipNumber = chipSelector;
}

- (int) numLines {
    return 0x10;
}

- (int) numColumns {
    return 14;
}

//- (Digit) getDigit: (int) index ofLine: (int) line {
//    if (line != self->bufferedReg) {
//        [self->bus readRamLocation: line ofChip: *self->chipNumber into: self->buffer];
//        self->bufferedReg = line;
//    }
//    return self->buffer[index];
//}

- (BOOL) chipNumberValid {
    int chip = *self->chipNumber;
    return chip >= 0x00 && chip <= 0x3f;
}

- (BOOL) getDigitsForLine: (int) line into: (Digits_14) data {
    return [self chipNumberValid] 
        && [self->bus readRamLocation: line ofChip: *self->chipNumber into: data];
}

- (void) setDigit: (int) index ofLine: (int) line to: (int) value {
    Digits_14 buffer;
    if ([self chipNumberValid]) {
        [self->bus readRamLocation: line ofChip: *self->chipNumber into: buffer];
        buffer[index] = value;
        [self->bus writeRamLocation: line ofChip: *self->chipNumber from: buffer];
    }
}

@end
