//
//  RomChip.m
//  HP41
//
//  Created by greg on Wed Aug 13 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//
//  Modified by Frederic - April 2008

#import "RomChip.h"


@implementation RomChip

+ (id) fromFile: (NSString *) path {
    id rom = [[[RomChip alloc] initWritable: NO] autorelease];
    [rom loadFromFile: path];
    return rom;
}

+ (id) blankEprom {
    return [[[RomChip alloc] initWritable: YES] autorelease];
}

- (id) initWritable: (BOOL) writable {
    isWritable = writable;
    return self;
}

- (void) loadFromFile: (NSString *) path {
    id data = [NSData dataWithContentsOfFile: path];
    //NSLog(@"Size of words: %d", sizeof(words));
   
    // We read an int and we swap it before storing it
    // This compensates between running on a PPC and intel
    int i;
    NSRange range;
    range.location = 0;
    range.length = 2;
    for (i = 0; i < 0x1000; i++) {
        int tmp = 0;
        int tmp2 = 0;
        [data getBytes:&tmp range:range];
        range.location += 2;
        tmp2 = CFSwapInt16BigToHost(tmp);
        words[i] =tmp2;
    }
    
    // Frederic - Original
    // [data getBytes: self->words length: sizeof(words)];
}

- (int) readLocation: (int) addr {
    return words[addr];
}

- (BOOL) writeLocation: (int) addr from: (int) data {
    if (isWritable) {
        words[addr] = data;
        return YES;
    }
    else
        return NO;
}

@end
