//
//  DataOperations.h
//  HP41
//
//  Created by greg on Thu Aug 14 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "DataTypes.h"

typedef enum ArithOp {
    ADD,
    SUB
} ArithOp;

void CopyDigits(const Digit *src, Digit *dst, int count);
void FillDigits(Digit *dst, Digit value, int count);
void BitsToDigits(int bits, Digit *digits, int ndigits);
void DigitsToBits(Digit *digits, int *bits, int nbits);
void DigitsToBitsWrap(Digits_14 digits, int *bits, int start, int count);
void BitsToDigitsWrap(int bits, Digits_14 digits, int start, int count);

void AddOrSubtractDigits(
    ArithOp op, ArithMode mode,
    Digit src1[], Digit src2[], Digit dst[],  
    int start, int count, 
    Bit *carry, Bit *zero);

void ExchangeDigits(Digit x[], Digit y[], int start, int count);
void ShiftDigitsLeft(Digit x[], int start, int count);
void ShiftDigitsRight(Digit x[], int start, int count);
void AndDigits(Digit x[], Digit y[], Digit z[], int start, int count);
void OrDigits(Digit x[], Digit y[], Digit z[], int start, int count);
