//
//   HP41Font.m
//

#import <Cocoa/Cocoa.h>
//#import <Foundation/Foundation.h>
#include "HP41Font.h"

void LoadFont(DisplayFont font, NSString *rsrcName) {
    NSString *filename = [[NSBundle mainBundle] pathForResource: rsrcName ofType: @"hpfont"];
    id data = [NSData dataWithContentsOfFile: filename];
    
    // We read an int and we swap it before storing it
    int i;
    NSRange range;
    range.location = 0;
    range.length = 4;
    for (i = 0; i < 127; i++) {
        int tmp = 0;
        int tmp2 = 0;
        [data getBytes:&tmp range:range];
        range.location += 4;
        tmp2 = CFSwapInt32BigToHost(tmp);
        font[i] =tmp2;
    }
    
    // Frederic - Original
    //[data getBytes: font length: sizeof(DisplayFont)];
}

void LoadSegmentPaths(DisplaySegmentPaths paths, NSString *rsrcName) {
    int i;
    NSString *filename = [[NSBundle mainBundle] pathForResource: rsrcName ofType: @"geom"];
    id data = [NSData dataWithContentsOfFile: filename];
    id coder = [[NSKeyedUnarchiver alloc] initForReadingWithData: data];
    id dict = [coder decodeObjectForKey: @"bezierPaths"];
    for (i = 0; i < numDisplaySegments; i++) {
        paths[i] = [[dict objectForKey: [NSString stringWithFormat: @"%d", i]] retain];
        //printf("path[%d] = 0x%p\n", i, paths[i]);
    }
}
